//+------------------------------------------------------------------+
//|                                             Painmeter indicator  |
//|                                                            Mikko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Mikko"
#property link      "noneOfYOurBusiness"

#property indicator_separate_window
//#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Gray
#property indicator_color4 White
#property indicator_color5 Yellow
#property indicator_color6 Orange
#property indicator_color7 YellowGreen

double bullPain[];
double bearPain[];
double painDiff[];
double painMA[];
double buy[];
double sell[];
double symmetry[];

extern int ma = 30;
extern int count = 60; 
extern int step = 1;
extern int mamode = MODE_LWMA;
extern int period = 0;

/*
extern int count2 = 50; 
extern int step2 = 1; 
extern double multiplier2 = 2;

extern int count3 = 100; 
extern int step3 = 1; 
extern int multiplier3 = 3;
*/

int init() {

   IndicatorBuffers(7);

   SetIndexBuffer(0, painDiff);     
   SetIndexStyle(0, DRAW_LINE, EMPTY, 1);
   
   SetIndexBuffer(1, painMA);     
   SetIndexStyle(1, DRAW_LINE, EMPTY, 1);

   SetIndexBuffer(2, bullPain);     
   SetIndexStyle(2, DRAW_NONE, EMPTY, 1);

   SetIndexBuffer(3, bearPain);     
   SetIndexStyle(3, DRAW_NONE, EMPTY, 1);
   

      
   IndicatorShortName("Mikko PainMeter v3 "+count+"/"+ma);
   
   //SetIndexDrawBegin(0, 0);  
  
   
   return(0);
}
  
int deinit() {
   return(0);
}
     
int start() {
       
   int counted_bars=IndicatorCounted();
   int per = period;
   
   if(per == 0)
      per = Period();
       
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0)  
       counted_bars--;
       
   int limit = Bars - counted_bars;
   double move;
   int j;
   datetime lastDate;
      
   for(int i = limit; i >= 0; i--) {
       move = 0;
       bullPain[i] = 0;
       bearPain[i] = 0;

       int s = iBarShift(Symbol(), per, Time[i], false); // next in future bar minus 1 bar -> this close bar
       if(s == lastDate) {
         bullPain[i] = bullPain[i+1];
         bearPain[i] = bearPain[i+1];
         painMA[i] = painMA[i+1];
         painDiff[i] = painDiff[i+1];
       } else {
       int k;
       double nowval = (iHigh(Symbol(),per,s)+iLow(Symbol(),per,s)+iClose(Symbol(),per,s)*2)/4;
       
       for(k=1; k<count; k+=step) {
            j = i+k;
            int s2 = iBarShift(Symbol(), per, Time[j], false); // next in future bar minus 1 bar -> this close bar
            double jval = (iHigh(Symbol(),per,s2)+iLow(Symbol(),per,s2)+iClose(Symbol(),per,s2)*2)/4;
                  
              // volume does not represent deal count!
              double multiplier = 1; 
              
              /** Pain/ecstacy of loss for each step **/
              bullPain[i] += (jval-nowval)*multiplier;              
              bearPain[i] += (nowval-jval)*multiplier;

              /** Pain of gaining something and not cashing at the high point or
                  perfect entry ecstacy **/

               /*   
              int highPos = iHighest(Symbol(),0,MODE_HIGH,k,i);
              int lowPos = iLowest(Symbol(),0,MODE_LOW,k,i);
                                 
              if(High[highPos] > nowval)                            
                  bullPain[i] += High[highPos]-nowval;
                  
              if(Low[lowPos] < nowval)
                  bearPain[i] += nowval-Low[lowPos];
               */
             
           painDiff[i] = bearPain[i]-bullPain[i];
           }
       }         
      lastDate = s;
   }    
   
   if(ma != 0)
   for(i=limit; i>=0; i--) {
       painMA[i] = iMAOnArray(painDiff, 0, ma, 0, mamode, i);              
   }
   
   return(0);
}

double dist(double a, double b) {
   if(a > b)
      return(a-b);
   else
      return(b-a);
}